<id>
Gallery mod
</id>

<version>
SP1.31 Beta 2
</version>

<mod info>
Hello Yabbers,

this mod integrates a gallery in the YaBB-board.

**** Installation ****

( - uninstall BETA 1 )
- files : english.lng , Admin.pl , AdminEdit.pl , Display.pl , Profile.pl , SubList.pl , Subs.pl
- apply the mod.
- set the perl-path at the first line in GALLERY.PL and copy it in your /Sources folder , chmod 777 !
- copy the 2 empty files GALLERYALB.TXT and GALLERYPUB.TXT in your /Members folder , chmod them 666 !
- upload all GIFs in your /YaBBImages folder.
- make a album folder for example : public_html/Gallery/  ,  chmod 777 !
- to setup the gallery : 
	fill-in the gallery-fields in "FORUM PREFERENCES AND SETTINGS" in the Admin Center
	and the "GALLERY MEMBER SETTINGS"
- maybe you have to change some chmods if it doesn't work...


**** Upgrades ****

- create/rename/delete/publish album
- upload/rename/delete fotos/zip/tar
- public albums
- individual description,view
- caption ( you can use html-tags )
- profil-link and post-link
- support frontpage-pages

!!! thumbnailmaker doesn't work !!!


**** Explanations ****

- PROFILE- and POSTLINK shows only PUBLISHED ALBUMS from member.
- if GUESTACCESS is enabled and access for a user is disabled , then the USER CAN ACCESS AS GUEST.
- GUEST can access on PUBLIC ALBUMS.
- RIGHTS :
	ACCESS - rename album, rename fotos, edit info
	UPLOAD - all without publish	
	PUBLISH - publish
	MODERATOR - all and access to all albums

- ACCESS is necessary for the 3 other RIGHTS
- UPLOAD max 5 fotos + 1 zip at once. General limits can be set in admin-center.
- UPLOAD THUMBNAILS FIRST, then the fotos, because if you reach limit you cannot upload more.
- if you uploaded the Fotos and enabled the thumbnail, but didn't uploaded thumbnails then you will see placeholders.
	so you have to disable thumbnail or upload them to see the fotos.
- in EDIT INFO you only can set PERSONAL SETTINGS if admin allowed.

**** Testboard ****

http://www.archiboard.de/TESTBOARD/cgi-bin/yabb/YaBB.pl

login: test
pw: test

login: test2
pw: test2

**** Credits ****

Versions for SP1.1 and SP1.31 are available.

Big Thanx to Brain Brian, caliman, Dam Yankee, delrick, DocRST, Gilles, Ikari-Kun, Javvy, Jazhawk,
	LoonyPandora, Michael Prager, Mr God Sir [Christer], mzbeanz, Panther, Parham, Poltergeist,
	qersys, tenl, T-Master, WeBRecka[ZG], Wiehemeier, Xonder for help and testing.
On this way i can give a little bit back to the YaBB-community ;-)

Please help me to develop this mod.

**** Copyright by Le Trong Hoang ****

Use of this code is not allowed outside the copyright holder's intentions.
I spent a month of work, some days over 5 hours to create that mod, so please be fair.
This mod can use for non-commercial YaBB-boards. Use on commercial boards is forbidden until I give permission .
Changing code or implement it in another mod or program is forbidden until I give permission.
This mod can use by hackers to shot your webserver !
I will not stand responsible for any damage done to your server via this script.  
</mod info>

<author>
Le Trong Hoang
</author>

<homepage>
http://www.archiboard.de
</homepage>


<edit file>
english.lng
</edit file>

<search for>
if($MenuType == 1) {
</search for>

<add before>

### Gallery mod Beta 2 ####
$galltxt{'1'} = "Gallery Settings";
$galltxt{'2'} = "Enable gallery";
$galltxt{'3'} = "Absolute Directory to gallery ('/home/yourdomain/yabb/public_html/Gallery')";
$galltxt{'4'} = "Relative Directory to gallery ('../../public_html/Gallery')";
$galltxt{'5'} = "Enable guest-access";
$galltxt{'6'} = "Enable post-link";
$galltxt{'7'} = "Enable profile-link";
$galltxt{'8'} = "Enable personal settings";
$galltxt{'9'} = "Standards";
$galltxt{'10'} = "Enable description";
$galltxt{'11'} = "Description";
$galltxt{'12'} = "Enable artist";
$galltxt{'13'} = "Artist";
$galltxt{'14'} = "Enable caption";
$galltxt{'15'} = "Enable personal view";
$galltxt{'16'} = "Height of fotos";
$galltxt{'17'} = "[pixels] (blank = show originals size)";
$galltxt{'18'} = "Columns of fotos";
$galltxt{'19'} = "Enable thumbnails (disable = show originals)";
$galltxt{'20'} = "Names of thumbnails start with";
$galltxt{'21'} = "Height of thumbnails for thumbnailmaker";
$galltxt{'22'} = "Enable zip / tar";
$galltxt{'23'} = "Upload limits";
$galltxt{'24'} = "Max albums";
$galltxt{'25'} = "Max album fotos";
$galltxt{'26'} = "Max album size [bytes]";
$galltxt{'27'} = "Max gallery fotos";
$galltxt{'28'} = "Max gallery size [bytes]";
$galltxt{'29'} = "Gallery Member Settings";
$galltxt{'30'} = "Member";
$galltxt{'31'} = "Codes";
$galltxt{'32'} = "Access";
$galltxt{'33'} = "Upload";
$galltxt{'34'} = "Publish";
$galltxt{'35'} = "Moderator";
$galltxt{'36'} = "All";
$galltxt{'37'} = "Public albums";
$galltxt{'38'} = "Gallery";
$galltxt{'39'} = "Create album";
$galltxt{'40'} = "Rename";
$galltxt{'41'} = "Delete";
$galltxt{'42'} = "Upload fotos";
$galltxt{'43'} = "Thumbnails";
$galltxt{'44'} = "Edit info";
$galltxt{'45'} = "Albums";
$galltxt{'46'} = "Privat album";
$galltxt{'47'} = "Published album";
$galltxt{'48'} = "Public album";
$galltxt{'49'} = "Enabled";
$galltxt{'50'} = "Disabled";
$galltxt{'51'} = "Albumname :";
$galltxt{'52'} = "Do you really want <b>rename</b>";
$galltxt{'53'} = "  to  ";
$galltxt{'54'} = "Do you really want <b>delete</b>";
$galltxt{'55'} = "Do you really want ";
$galltxt{'56'} = "Unpublish";
$galltxt{'57'} = "Album";
$galltxt{'58'} = "Fotos";
$galltxt{'59'} = "Size";
$galltxt{'60'} = "Limits";
$galltxt{'61'} = "Contents";
$galltxt{'62'} = "Select files";
$galltxt{'63'} = "zip / tar";

$galltxt{'66'} = "Personal Settings";
$galltxt{'67'} = "Admin Settings";
$galltxt{'68'} = "[blank]";
$galltxt{'69'} = "Save";
$galltxt{'70'} = "Captions";
$galltxt{'71'} = "Can't create a new album, because name already exist or contains unallowed signs or ending !<br>Please try with another name.";
$galltxt{'72'} = "Can't rename, because name already exist or contains unallowed signs or ending !<br>Please try with another name.";
$galltxt{'73'} = "Upload thumbnails first. They have to start with : ";
$galltxt{'74'} = "Can't write : ";
$galltxt{'75'} = "Can't create a new album, because reached limit.";
$galltxt{'76'} = "Can't upload, because reached limit.";

</add before>

<search for>
	$img{'website_sm'} = qq~<font size="1" class="imgwindowbg">$txt{'515'}</font>~;
</search for>

<add after>
	$img{'gallery'} = qq~<font size="1" class="imgwindowbg">$galltxt{'38'}</font>~;
</add after>

<search for>
	$img{'website_sm'} = qq~<img src="$imagesdir/www.gif" alt="$txt{'515'}" border="0">~;
</search for>

<add after>
	$img{'gallery'} = qq~<img src="$imagesdir/gallery.gif" alt="$galltxt{'38'}" border="0"> <font size="1" class="imgmenu">$galltxt{'38'}</font>~;
</add after>


<edit file>
Sources/Admin.pl
</edit file>

<search for>
        - <a href="$cgi;action=modagreement">$txt{'764'}</a><br>
</search for>

<add after>
        - <a href="$cgi;action=setgallery">$galltxt{'29'}</a><br>
</add after>


<edit file>
Sources/AdminEdit.pl
</edit file>

<search for>
sub SetReserve {
</search for>

<add before>

sub SetGallery {
	&is_admin;
	$yymain .= qq~
<form action="$cgi;action=setgallery2" name="galmembers" method="POST">
<table width="40%" border="0" cellspacing="1" cellpadding="0" bgcolor="$color{'bordercolor'}" class="bordercolor" align="center">
  <tr>
  <td>
  <table width="100%" border="0" cellspacing="0" cellpadding="6" align="center">
    <tr>
    <td class="titlebg" bgcolor="$color{'titlebg'}" colspan="6">
    <img src="$imagesdir/gallery.gif" alt="" border="0" align="absmiddle">
    <font size=2 class="text1" color="$color{'titletext'}"><b>$galltxt{'29'}</b></font></td>
  </tr><tr>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}" align="center">$galltxt{'30'}</td>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}" align="center">$galltxt{'31'}</td>
    <td width="10%" class="windowbg2" bgcolor="$color{'windowbg2'}" align="center">$galltxt{'32'}</td>
    <td width="10%" class="windowbg2" bgcolor="$color{'windowbg2'}" align="center">$galltxt{'33'}</td>
    <td width="10%" class="windowbg2" bgcolor="$color{'windowbg2'}" align="center">$galltxt{'34'}</td>
    <td width="10%" class="windowbg2" bgcolor="$color{'windowbg2'}" align="center">$galltxt{'35'}</td>

  </tr>~;

	fopen(LIST, "$memberdir/memberlist.txt");
	fopen(GALLERY, "$memberdir/gallerymb.txt");
	@member = <LIST>;
	@galinfo = <GALLERY>;
	chomp(@member);
	chomp(@galinfo);
	fclose(LIST);
	fclose(GALLERY);
	
	my @mbnamesx;
	my @mbcodesx;
	my @mbaccx;
	my @mbuplx;
	my @mbpubx;
	my @mbmodx;

	my @mbnames;
	my @mbcodes;
	my @mbacc;
	my @mbupl;
	my @mbpub;
	my @mbmod;

	foreach(@galinfo) { 
		my @Mb=split(/ /,$_);
		push(@mbnamesx,$Mb[0]);
		push(@mbcodesx,$Mb[1]);
		my @Mbrights=split(//,$Mb[2]);
		push(@mbaccx,$Mbrights[0]);
		push(@mbuplx,$Mbrights[1]);
		push(@mbpubx,$Mbrights[2]);
		push(@mbmodx,$Mbrights[3]);
	}

	my @newmember=@member;
	my $jn=join(" ",@mbnamesx);
	my $count=0;
	foreach(@member) { 
		if(index($jn,$_) >= 0) { splice(@newmember,$count,1); }
		else { $count++; }
	}
	push(@mbnamesx,@newmember);

	my @galmb;
	my @mbsort=sort(@mbnamesx);
	my $mbnum=@mbsort;
	my $mbnumb=@mbnamesx;
	for(my $i=0;$i<=$mbnum;$i++) {
		for(my $j=0;$j<=$mbnumb;$j++) { 
			 if($mbsort[$i] eq $mbnamesx[$j]) { push(@galmb,"$mbnamesx[$j] $mbcodesx[$j] $mbaccx[$j]$mbuplx[$j]$mbpubx[$j]$mbmodx[$j]"); }
		}
	}

	splice(@galmb,$mbnum);

	foreach(@galmb) { 
		my @Mb=split(/ /,$_);
		push(@mbnames,$Mb[0]);
		if($Mb[1]) { push(@mbcodes,$Mb[1]); }
		else { my $random=int rand(99999999); $random=sprintf ("%08d", $random); push(@mbcodes,$random); }
		my @Mbrights=split(//,$Mb[2]);
		push(@mbacc,$Mbrights[0]);
		push(@mbupl,$Mbrights[1]);
		push(@mbpub,$Mbrights[2]);
		push(@mbmod,$Mbrights[3]);
	}

	$yymain .= qq~
	<script language="JavaScript1.2" type="text/javascript">
	<!--
		function checkacc() { for (var i = 0; i < $#mbnames+1; i++) { document.forms.galmembers.access[i].checked = true; } }
		function uncheckacc() { for (var i = 0; i < $#mbnames+1; i++) { document.forms.galmembers.access[i].checked = false; } }
		function checkupl() { for (var i = 0; i < $#mbnames+1; i++) { document.forms.galmembers.upload[i].checked = true; } }
		function uncheckupl() { for (var i = 0; i < $#mbnames+1; i++) { document.forms.galmembers.upload[i].checked = false; } }
		function checkpub() { for (var i = 0; i < $#mbnames+1; i++) { document.forms.galmembers.publish[i].checked = true; } }
		function uncheckpub() { for (var i = 0; i < $#mbnames+1; i++) { document.forms.galmembers.publish[i].checked = false; } }
		function checkmod() { for (var i = 0; i < $#mbnames+1; i++) { document.forms.galmembers.moderator[i].checked = true; } }
		function uncheckmod() { for (var i = 0; i < $#mbnames+1; i++) { document.forms.galmembers.moderator[i].checked = false; } }
	//-->
	</script>~;
	$yymain .= qq~<tr><td class="windowbg2" bgcolor="$color{'windowbg2'}" align="center">$galltxt{'36'}</td>
		<td class="windowbg2" bgcolor="$color{'windowbg2'}"></td>
		<td class="windowbg2" bgcolor="$color{'windowbg2'}" align="center"><input type="checkbox" onclick="if (this.checked) checkacc(); else uncheckacc();"></td>
		<td class="windowbg2" bgcolor="$color{'windowbg2'}" align="center"><input type="checkbox" onclick="if (this.checked) checkupl(); else uncheckupl();"></td>
		<td class="windowbg2" bgcolor="$color{'windowbg2'}" align="center"><input type="checkbox" onclick="if (this.checked) checkpub(); else uncheckpub();"></td>
		<td class="windowbg2" bgcolor="$color{'windowbg2'}" align="center"><input type="checkbox" onclick="if (this.checked) checkmod(); else uncheckmod();"></td></tr>~;

	$count=0;
	foreach(@mbnames) {
		$yymain .= qq~<tr><td class="windowbg2" bgcolor="$color{'windowbg2'}" align="left"><input name="name" type="text" size="15" value="$_" readonly></td>
			<td class="windowbg2" bgcolor="$color{'windowbg2'}" align="center"><input name="code" type="text" size="9" value="$mbcodes[$count]" readonly></td>
			<td class="windowbg2" bgcolor="$color{'windowbg2'}" align="center"><input type=checkbox name="access" id="access" value="$count" $accchecked~;
		if($mbacc[$count]) { $yymain .= qq~checked~; }
		$yymain .= qq~></td><td class="windowbg2" bgcolor="$color{'windowbg2'}" align="center"><input type=checkbox name="upload" id="upload" value="$count" $uplchecked~;
		if($mbupl[$count]) { $yymain .= qq~checked~; }
		$yymain .= qq~></td><td class="windowbg2" bgcolor="$color{'windowbg2'}" align="center"><input type=checkbox name="publish" id="publish" value="$count" $pubchecked~;
		if($mbpub[$count]) { $yymain .= qq~checked~; }
		$yymain .= qq~></td><td class="windowbg2" bgcolor="$color{'windowbg2'}" align="center"><input type=checkbox name="moderator" id="moderator" value="$count" $modchecked~;
		if($mbmod[$count]) { $yymain .= qq~checked~; }
		$yymain .= qq~></td></tr>~;
		$count++;
	}

	$yymain .= qq~
  <tr>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}" colspan="6" align="center" valign="middle">
    <BR><input type=submit value="$txt{'10'}">
    </td>
  </tr>
  </table>
</td>
</tr>
</table>
</form>~;

	&template;
	exit;
}

sub SetGallery2 {
	&is_admin;

	my @mbname=split(/, /,$FORM{'name'});
	my @mbcode=split(/, /,$FORM{'code'});
	my @mbacc;
	my @mbupl;
	my @mbpub;
	my @mbmod;

	my @acc=split(/, /,$FORM{'access'});
	foreach(@acc) { $mbacc[$_]="1"; }
	my @upl=split(/, /,$FORM{'upload'});
	foreach(@upl) { $mbupl[$_]="1"; }
	my @pub=split(/, /,$FORM{'publish'});
	foreach(@pub) { $mbpub[$_]="1"; }
	my @mod=split(/, /,$FORM{'moderator'});
	foreach(@mod) { $mbmod[$_]="1"; }

	my @Mbinfo;
	my $mbnum=@mbname;
	for(my $i=0;$i<=$mbnum;$i++) {
		if(!$mbacc[$i]) { $mbacc[$i]="0" }
		if(!$mbupl[$i]) { $mbupl[$i]="0" }
		if(!$mbpub[$i]) { $mbpub[$i]="0" }
		if(!$mbmod[$i]) { $mbmod[$i]="0" }
		$Mbinfo[$i]="$mbname[$i] $mbcode[$i] $mbacc[$i]$mbupl[$i]$mbpub[$i]$mbmod[$i]\n";
	}

	if(!$mbname[$mbnum]) { splice(@Mbinfo,$mbnum); }

	fopen(FILE, ">$memberdir/gallerymb.txt");
	print FILE @Mbinfo;		
	fclose(FILE);

	$yySetLocation = qq~$cgi;action=admin~;
	&redirectexit;

}

</add before>

<search for>
	if ($timeselected == 6) { $tsl6 = " selected" } elsif ($timeselected == 5) { $tsl5 = " selected" } elsif ($timeselected == 4) { $tsl4 = " selected" } elsif ($timeselected == 3) { $tsl3 = " selected" } elsif ($timeselected == 2) { $tsl2 = " selected" } else { $tsl1 = " selected" }
</search for>

<add after>
	if ($allowgal) { $allowgalchecked = "checked" }
	if ($allowgst) { $allowgstchecked = "checked" }
	if ($allowpstlnk) { $allowpstlnkchecked = "checked" }
	if ($allowprolnk) { $allowprolnkchecked = "checked" }
	if ($allowset) { $allowsetchecked = "checked" }
	if ($ad_descrip_on) { $ad_descrip_onchecked = "checked" }
	if ($ad_fotograf_on) { $ad_fotograf_onchecked = "checked" }
	if ($ad_caption_on) { $ad_caption_onchecked = "checked" }
	if ($ad_view_on) { $ad_view_onchecked = "checked" }
	if ($ad_thumbs_on) { $ad_thumbs_onchecked = "checked" }
	if ($ad_zip_on) { $ad_zip_onchecked = "checked" }
</add after>

<search for>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type=text name="timeoffset" size="5" value="$timeoffset"></td>
  </tr><tr>
    <td colspan=2 class="windowbg2" bgcolor="$color{'windowbg2'}">
    <HR size=1 width="100%" class="hr"></td>
</search for>

<add after>
  </tr><tr>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><b><font size="2">$galltxt{'1'}</font></b></td>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"></td>
  </tr><tr>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$galltxt{'2'}</font></td>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type=checkbox name="allowgal"$allowgalchecked></td>
  </tr><tr>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$galltxt{'3'}</font></td>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type=text name="galleryabs" size="45" value="$galleryabs"></td>
  </tr><tr>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$galltxt{'4'}</font></td>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type=text name="galleryrel" size="45" value="$galleryrel"></td>
  </tr><tr>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$galltxt{'5'}</font></td>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type=checkbox name="allowgst"$allowgstchecked></td>
  </tr><tr>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$galltxt{'6'}</font></td>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type=checkbox name="allowpstlnk"$allowpstlnkchecked></td>
  </tr><tr>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$galltxt{'7'}</font></td>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type=checkbox name="allowprolnk"$allowprolnkchecked></td>
  </tr><tr>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$galltxt{'8'}</font></td>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type=checkbox name="allowset"$allowsetchecked></td>
  </tr><tr>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><b><font size="1">$galltxt{'9'}</font></b></td>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"></td>
  </tr><tr>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$galltxt{'10'}</font></td>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type=checkbox name="ad_descrip_on"$ad_descrip_onchecked></td>
  </tr><tr>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$galltxt{'11'}</font></td>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type=text name="ad_descrip" size="45" value="$ad_descrip"></td>
  </tr><tr>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$galltxt{'12'}</font></td>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type=checkbox name="ad_fotograf_on"$ad_fotograf_onchecked></td>
  </tr><tr>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$galltxt{'13'}</font></td>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type=text name="ad_fotograf" size="45" value="$ad_fotograf"></td>
  </tr><tr>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$galltxt{'14'}</font></td>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type=checkbox name="ad_caption_on"$ad_caption_onchecked></td>
  </tr><tr>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$galltxt{'15'}</font></td>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type=checkbox name="ad_view_on"$ad_view_onchecked></td>
  </tr><tr>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$galltxt{'16'} $galltxt{'17'}</font></td>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type=text name="ad_ft_height" size="5" value="$ad_ft_height"></td>
  </tr><tr>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$galltxt{'18'}</font></td>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type=text name="ad_ft_col" size="5" value="$ad_ft_col"></td>
  </tr><tr>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$galltxt{'19'}</font></td>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type=checkbox name="ad_thumbs_on"$ad_thumbs_onchecked></td>
  </tr><tr>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$galltxt{'20'}</font></td>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type=text name="ad_th_name" size="45" value="$ad_th_name"></td>
  </tr><tr>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$galltxt{'21'}</font></td>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type=text name="ad_th_height" size="5" value="$ad_th_height"></td>
  </tr><tr>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$galltxt{'22'}</font></td>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type=checkbox name="ad_zip_on"$ad_zip_onchecked></td>
  </tr><tr>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><b><font size="1">$galltxt{'23'}</font></b></td>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"></td>
  </tr><tr>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$galltxt{'24'}</font></td>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type=text name="maxalbum" size="5" value="$maxalbum"></td>
  </tr><tr>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$galltxt{'25'}</font></td>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type=text name="maxfoto" size="5" value="$maxfoto"></td>
  </tr><tr>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$galltxt{'26'}</font></td>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type=text name="maxsize" size="10" value="$maxsize"></td>
  </tr><tr>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$galltxt{'27'}</font></td>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type=text name="maxgalfoto" size="5" value="$maxgalfoto"></td>
  </tr><tr>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$galltxt{'28'}</font></td>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type=text name="maxgalsize" size="10" value="$maxgalsize"></td>
  </tr><tr>
    <td colspan=2 class="windowbg2" bgcolor="$color{'windowbg2'}">
    <HR size=1 width="100%" class="hr"></td>
</add after>

<search for>
	# Set as 0 or 1 if box was checked or not
</search for>

<add before>
	push(@onoff, "allowgal", "allowgst", "allowpstlnk", "allowprolnk", "allowset", "ad_descrip_on", "ad_fotograf_on", "ad_caption_on", "ad_view_on", "ad_thumbs_on", "ad_zip_on");

</add before>

<search for>
	# Set as 0 or 1 if box was checked or not
</search for>

<add after>
	$allowgal = $FORM{'allowgal'} ? 1 : 0;
	$allowgst = $FORM{'allowgst'} ? 1 : 0;
	$allowpstlnk = $FORM{'allowpstlnk'} ? 1 : 0;
	$allowprolnk = $FORM{'allowprolnk'} ? 1 : 0;
	$allowset = $FORM{'allowset'} ? 1 : 0;
	$ad_descrip_on = $FORM{'ad_descrip_on'} ? 1 : 0;
	$ad_fotograf_on = $FORM{'ad_fotograf_on'} ? 1 : 0;
	$ad_caption_on = $FORM{'ad_caption_on'} ? 1 : 0;
	$ad_view_on = $FORM{'ad_view_on'} ? 1 : 0;
	$ad_thumbs_on = $FORM{'ad_thumbs_on'} ? 1 : 0;
	$ad_zip_on = $FORM{'ad_zip_on'} ? 1 : 0;

</add after>

<search for>
	$timeoffset = $FORM{'timeoffset'} || 0;
</search for>

<add after>
	$galleryabs = $FORM{'galleryabs'} || "$boardurl/Gallery";
	$galleryrel = $FORM{'galleryrel'} || "$boarddir/Gallery";
	$ad_descrip = $FORM{'ad_descrip'} || "";
	$ad_fotograf = $FORM{'ad_fotograf'} || "";
	$ad_ft_height = $FORM{'ad_ft_height'} || "";
	$ad_ft_col = $FORM{'ad_ft_col'} || 4;
	$ad_th_name = $FORM{'ad_th_name'} || "th_";
	$ad_th_height = $FORM{'ad_th_height'} || 150;
	$maxalbum = $FORM{'maxalbum'} || "";
	$maxfoto = $FORM{'maxfoto'} || "";
	$maxsize = $FORM{'maxsize'} || "";
	$maxgalfoto = $FORM{'maxgalfoto'} || "";
	$maxgalsize = $FORM{'maxgalsize'} || "";
</add after>

<search for>
########## Feature Settings ##########
</search for>

<add before>

########## Gallery Settings ##########

\$allowgal = "$allowgal";				# enable gallery
\$galleryabs = "$galleryabs";	# /home/yourserverid/yourdomain/yabb/public_html/Album
\$galleryrel = "$galleryrel";				# ../../public_html/Album
\$allowgst = "$allowgst";				# enable guestaccess
\$allowpstlnk = "$allowpstlnk";				# enable postlink
\$allowprolnk = "$allowprolnk";				# enable profilelink
\$allowset = "$allowset";				# enable personal settings
\$ad_descrip_on = "$ad_descrip_on";			# enable description
\$ad_descrip = "$ad_descrip";				# description
\$ad_fotograf_on = "$ad_fotograf_on";			# enable fotograf
\$ad_fotograf = "$ad_fotograf";				# fotograf
\$ad_caption_on = "$ad_caption_on";			# enable caption
\$ad_view_on = "$ad_view_on";				# enable personal view
\$ad_ft_height = "$ad_ft_height";			# height of fotos
\$ad_ft_col = "$ad_ft_col";				# column of fotos
\$ad_thumbs_on = "$ad_thumbs_on";			# enable thumbnails
\$ad_th_name = "$ad_th_name";				# names of thumbnails start with
\$ad_th_height = "$ad_th_height";			# height of thumbnails
\$ad_zip_on = "$ad_zip_on";				# enable zip / tar
\$maxalbum = "$maxalbum";				# max albums limit
\$maxfoto = "$maxfoto";					# max album foto limit
\$maxsize = "$maxsize";					# max album size limit
\$maxgalfoto = "$maxgalfoto";				# max gallery foto limit
\$maxgalsize = "$maxgalsize";				# max gallery size limit

</add before>


<edit file>
Sources/Display.pl
</edit file>

<search for>
				$sendm = qq~$menusep<a href="$cgi;action=imsend;to=$useraccount{$musername}">$img{'message_sm'}</a>~;
</search for>

<add after>
				if($allowpstlnk) {
					my $uname=lc($musername);
					$sendm .= qq~ <a href="$cgi;action=gallery;useralbum=$uname"><img src="$imagesdir/camera.gif" alt="$galltxt{'37'}" border="0"></a>~;
				}
</add after>


<edit file>
Sources/Profile.pl
</edit file>

<search for>
        <td><font size=2><a href="$memsettings[4]" target=_blank>$memsettings[3]</a></font></td>
</search for>

<replace>
        <td><font size=2><a href="$memsettings[4]" target=_blank>$memsettings[3]</a></font></td>~;
	if($allowprolnk) {
		my $uname=lc($INFO{'username'});
		$yymain .= qq~</tr><tr><td><font size=2><b>$galltxt{'38'}:</b></font></td><td><a href="$cgi;action=gallery;useralbum=$uname"><font size=2>$galltxt{'37'}</font></a></td>~;
	}
	$yymain .= qq~
</replace>


<edit file>
Sources/SubList.pl
</edit file>

<search for>
%director=(
</search for>

<add after>
'setgallery',"AdminEdit.pl&SetGallery",
'setgallery2',"AdminEdit.pl&SetGallery2",
'gallery',"Gallery.pl&Gallery",
'albcrt',"Gallery.pl&albcrt",
'albren',"Gallery.pl&albren",
'albdel',"Gallery.pl&albdel",
'albpub',"Gallery.pl&albpub",
'fotoupl',"Gallery.pl&fotoupl",
'fotoren',"Gallery.pl&fotoren",
'fotodel',"Gallery.pl&fotodel",
'editinfo',"Gallery.pl&editinfo",
'caption',"Gallery.pl&caption",
</add after>


<edit file>
Sources/Subs.pl
</edit file>

<search for>
	if($settings[7] eq 'Administrator') { $yymenu .= qq~$menusep<a href="$cgi;action=admin">$img{'admin'}</a>~; }
</search for>

<add after>
	if($allowgal) { $yymenu .= qq~$menusep<a href="$cgi;action=gallery">$img{'gallery'}</a>~; }
</add after>

<search for>
	if ($ENV{REQUEST_METHOD} eq 'POST')
	{
		read(STDIN, my $input, $ENV{CONTENT_LENGTH});
		split_string(\$input, \%FORM) 
	}
</search for>

<replace>
	if ($ENV{REQUEST_METHOD} eq 'POST') {
		if ($ENV{CONTENT_TYPE} =~ /multipart\/form-data/) {			
			require CGI; import CGI qw(:standard);
			my $query = new CGI;
			my $zipfile = $query->param('uplzip');
			my $tmpfile = $query->tmpFileName($zipfile);

			local( $/, *TMP );
			open(TMP,"$tmpfile");
			my $filedata = <TMP>;
			close(TMP);

			open(TMP2,">$memberdir/$zipfile");
			print TMP2 $filedata;
			close(TMP2);

			for(my $x=1;$x<=5;$x++) {	
				$feld = "uplfoto".$x;
				my $file = $query->param($feld);
				my $tpfl = $query->tmpFileName($file);

				local( $/, *TMP );
				open(TMP,"$tpfl");
				my $filedata = <TMP>;
				close(TMP);

				open(TMP2,">$memberdir/$file");
				print TMP2 $filedata;
				close(TMP2);
			}
		}
		else {
			read(STDIN, my $input, $ENV{CONTENT_LENGTH});
			split_string(\$input, \%FORM) 
		}
	
	}
</replace>